package com.softmoore.benchmark.scimark2.v2;


public class SOR
  {
    public static final Double num_flops(Integer M, Integer N, Integer num_iterations)
      {
        Double Md = (double) M;
        Double Nd = (double) N;
        Double num_iterD = (double) num_iterations;

        return (Md - 1) * (Nd - 1) * num_iterD * 6.0;
      }


    public static final void execute(Double omega, Double G[][], Integer num_iterations)
      {
        Integer M = G.length;
        Integer N = G[0].length;

        Double omega_over_four = omega * 0.25;
        Double one_minus_omega = 1.0 - omega;

        // update interior points
        //
        Integer Mm1 = M - 1;
        Integer Nm1 = N - 1;
        for (Integer p = 0; p < num_iterations; p++)
          {
            for (Integer i = 1; i < Mm1; i++)
              {
                Double[] Gi = G[i];
                Double[] Gim1 = G[i - 1];
                Double[] Gip1 = G[i + 1];
                for (Integer j = 1; j < Nm1; j++)
                  {
                    Gi[j] = omega_over_four * (Gim1[j] + Gip1[j] + Gi[j - 1] + Gi[j + 1])
                        + one_minus_omega * Gi[j];
                  }
              }
          }
      }
  }
