package com.softmoore.util;


import java.text.NumberFormat;


/**
 * collection of useful printing utility methods
 */
public class PrintUtil
  {
    /**
     * Formats and prints a 2-dimensional array of double in standard matrix form.
     */
    public static void printMatrix(double[][] a, int fractionDigits)
      {
        NumberFormat formatter = NumberFormat.getNumberInstance();
        formatter.setMaximumFractionDigits(fractionDigits);
        formatter.setMinimumFractionDigits(fractionDigits);

        for (int i = 0;  i < a.length;  ++i)
          {
            for (int j = 0;  j < a[i].length;  ++j)
                System.out.print(formatter.format(a[i][j]) + " ");

            System.out.println();
          }

        System.out.println();
      }


    /**
     * Formats and prints a 2-dimensional array of Double in standard matrix form.
     */
    public static void printMatrix(Double[][] a, int fractionDigits)
      {
        NumberFormat formatter = NumberFormat.getNumberInstance();
        formatter.setMaximumFractionDigits(fractionDigits);
        formatter.setMinimumFractionDigits(fractionDigits);

        for (int i = 0;  i < a.length;  ++i)
          {
            for (int j = 0;  j < a[i].length;  ++j)
                System.out.print(formatter.format(a[i][j]) + " ");

            System.out.println();
          }

        System.out.println();
      }


    /**
     * formats/prints a 1-dimensional array of double
     */
    public static void printVector(double[] v, int fractionDigits)
      {
        NumberFormat formatter = NumberFormat.getNumberInstance();
        formatter.setMaximumFractionDigits(fractionDigits);
        formatter.setMinimumFractionDigits(fractionDigits);

        for (int i = 0;  i < v.length;  ++i)
            System.out.print(formatter.format(v[i]) + " ");

        System.out.println();
      }


    /**
     * formats a double for printing
     */
    public static String convertDouble(double x, int fractionDigits)
      {
        NumberFormat formatter = NumberFormat.getNumberInstance();
        formatter.setMaximumFractionDigits(fractionDigits);
        formatter.setMinimumFractionDigits(fractionDigits);

        return formatter.format(x);
      }


    /**
     * formats/prints a double
     */
    public static void printDouble(double x, int fractionDigits)
      {
        System.out.println(convertDouble(x, fractionDigits));
      }
  }
