package test;


import com.softmoore.math.MatrixUtil;
import com.softmoore.util.StopWatch;


public class TimedTestMatrixMultiplication
  {
    @SuppressWarnings("unused")
    public static void main(String[] args)
      {
        // all matrices are n by n
        int n = 1000;

        // initialize matrices
        double a1[][] = new double[n][n];
        double b1[][] = new double[n][n];
        Double a2[][] = new Double[n][n];
        Double b2[][] = new Double[n][n];
        
        for (int i = 0;  i < n;  ++i)
          {
            for (int j = 0;  j < n;  ++j)
              {
                double xa = Math.random();
                a1[i][j] = xa;
                a2[i][j] = xa;
                
                double xb = Math.random();
                b1[i][j] = xb;
                b2[i][j] = xb;
              }
          }
        

        StopWatch timer = new StopWatch();

        // test first with matrices of double
        timer.start();
        double c1[][] = MatrixUtil.multiply(a1, b1);
        timer.stop();
        
        double totalTime1 = timer.getElapsedTimeInSeconds();
        System.out.println("total time in for double = " + totalTime1 + " seconds");        
        System.out.println();
        
        // test second with matrices of Double
        timer.start();
        Double c2[][] = MatrixUtil.multiply(a2, b2);            
        timer.stop();
        
        double totalTime2 = timer.getElapsedTimeInSeconds();
        System.out.println("total time for Double = " + totalTime2 + " seconds");        
        System.out.println();
      }
  }
